# This is VERY messy... but was done VERY quickly, and works.

import pygame
import sys

from data import filepath

from BkGlobals import *
import BkMain

BORDER_X = 10
BORDER_Y = 10


class DifficultyOptions:
	__shared_state = {}
	def __init__(self):
		self.__dict__ = self.__shared_state
		
	def setWind(self, iValue):
		self.iWind = iValue
		
	def getWind(self):
		return self.iWind
		
	def setStartTime(self, iValue):
		self.iStartTime = iValue
		
	def getStartTime(self):
		return self.iStartTime
		
	def setNumBlocks(self, iValue):
		self.iNumBlocks = iValue
		
	def getNumBlocks(self):
		return self.iNumBlocks
		
	def setWinHeight(self, fValue):
		self.fWinHeight = fValue
		
	def getWinHeight(self):
		return self.fWinHeight
		
	def setWinTime(self, iValue):
		self.iWinTime = iValue
		
	def getWinTime(self):
		return self.iWinTime
		

class DiffuciltyScreen:
	def __init__(self):	
		self.bQuit = False
		bOpen = True
		
		updateRect = self.setupScreen()
		while bOpen:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit(1)
				elif event.type == pygame.KEYDOWN:
					if event.dict["key"] == pygame.K_ESCAPE:
						bOpen = False
				elif event.type == pygame.MOUSEMOTION:
					pos = event.dict["pos"]
					
					pygame.display.update(self.updateScreen(pos, False))
					break
				elif event.type == pygame.MOUSEBUTTONUP:
					if event.dict["button"] == 1:				
					
						pygame.display.update(self.updateScreen(pos, True))
						
						if self.bQuit:
							bOpen = False
						break
						
						
	def setupScreen(self, iFontSize = 32):
		font = pygame.font.Font(pygame.font.get_default_font(), iFontSize)

		easySurf = font.render("Easy", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highEasySurf = font.render("Easy", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedEasySurf = font.render("Easy", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		mediumSurf = font.render("Medium", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highMediumSurf = font.render("Medium", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedMediumSurf = font.render("Medium", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		hardSurf = font.render("Hard", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highHardSurf = font.render("Hard", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedHardSurf = font.render("Hard", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		startWindSurf = font.render("Start Wind", True, TEXT_NORMAL_COLOUR).convert_alpha()
		startTimeSurf = font.render("Game Time", True, TEXT_NORMAL_COLOUR).convert_alpha()
		winTimeSurf = font.render("Win Time", True, TEXT_NORMAL_COLOUR).convert_alpha()
		winHeightSurf = font.render("Win Height", True, TEXT_NORMAL_COLOUR).convert_alpha()
		numBlocksSurf = font.render("No. Blocks", True, TEXT_NORMAL_COLOUR).convert_alpha()
			
			
		self.iTotalHeight = iTotalHeight = 8 * easySurf.get_height()
		self.iOptionWidth = iOptionWidth = max(startWindSurf.get_width(), startTimeSurf.get_width(), winTimeSurf.get_width(), winHeightSurf.get_width(), numBlocksSurf.get_width())
		self.iSelectionWidth = iSelectionWidth = easySurf.get_width() + BORDER_X + mediumSurf.get_width() + BORDER_X + hardSurf.get_width()
			
		if iOptionWidth + iSelectionWidth + 5 * BORDER_X > pygame.display.get_surface().get_width() or iTotalHeight + 2 * BORDER_Y > pygame.display.get_surface().get_height():
			return self.setupScreen(iFontSize - 1)	
			
		self.mainSurf = pygame.Surface((iOptionWidth + iSelectionWidth + 5 * BORDER_X, iTotalHeight + 4 * BORDER_Y)).convert()
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, iOptionWidth + iSelectionWidth + 3 * BORDER_X, iTotalHeight + 2 * BORDER_Y))
		self.pos = (pygame.display.get_surface().get_width() - self.mainSurf.get_width()) / 2, (pygame.display.get_surface().get_height() - self.mainSurf.get_height()) / 2
		
		return pygame.display.get_surface().blit(self.mainSurf, self.pos)
		
	def updateScreen(self, pos, bClick):
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, iOptionWidth + iSelectionWidth + 3 * BORDER_X, self.iTotalHeight + 2 * BORDER_Y))

			
			
			